#include <bluefruit.h>
#include <Wire.h>
#include <BMP180MI.h>
#include <DS18B20.h>
//#include <Adafruit_INA219.h>

#define GPS_FIX_LAT_ERR
#define GPS_FIX_LON_ERR
#define GPS_FIX_ALT_ERR
#define GPS_FIX_HDOP
#define GPS_FIX_VDOP
#define NMEAGPS_PARSE_SATELLITES
#define NMEAGPS_PARSE_SATELLITE_INFO
#define NMEAGPS_SAVE_TALKER_ID
#include <NMEAGPS.h>

//Adafruit_INA219 ina219;



#define I2C_ADDRESS 0x77
BMP180I2C bmp180(I2C_ADDRESS);

byte ds18b20_addr[8] = {0x28, 0x5d, 0x41, 0x11, 0x05, 0x00, 0x00, 0xdc};
DS18B20 ds(27);

BLEService ln_service = BLEService(0x1819);
BLECharacteristic ls_char = BLECharacteristic(0x2A67);
BLECharacteristic pq_char = BLECharacteristic(0x2A69);

BLEService env_service = BLEService(UUID16_SVC_ENVIRONMENTAL_SENSING);
BLECharacteristic pressure_char = BLECharacteristic(0x2A6D);
BLECharacteristic temperature_char = BLECharacteristic(0x2A6E);

//const uint8_t nrf_service_uuid[16] = { 0x6e,0x40,0x00,0x01,0xb5,0xa3,0xf3,0x93,0xe0,0xa9,0xe5,0x0e,0x24,0xdc,0xca,0x9e };
/*const uint8_t nrf_service_uuid[] =
{
    0x9E, 0xCA, 0xDC, 0x24, 0x0E, 0xE5, 0xA9, 0xE0,
    0x93, 0xF3, 0xA3, 0xB5, 0x01, 0x00, 0x40, 0x6E
};*/
const uint8_t pressure_nrf_uuid[] =
{
    0x9E, 0xCA, 0xDC, 0x24, 0x0E, 0xE5, 0xA9, 0xE0,
    0x93, 0xF3, 0xA3, 0xB5, 0x04, 0x00, 0x40, 0x6E
};
const uint8_t temperature_nrf_uuid[] =
{
    0x9E, 0xCA, 0xDC, 0x24, 0x0E, 0xE5, 0xA9, 0xE0,
    0x93, 0xF3, 0xA3, 0xB5, 0x05, 0x00, 0x40, 0x6E
};

//BLEService nrf_service = BLEService(0x2005);
BLECharacteristic pressure_nrf_char = BLECharacteristic(pressure_nrf_uuid);
BLECharacteristic temperature_nrf_char = BLECharacteristic(temperature_nrf_uuid);

BLEService custom_service = BLEService(0x2000);
BLECharacteristic write_char = BLECharacteristic(0x2001);
BLECharacteristic sat_char = BLECharacteristic(0x2002);
BLECharacteristic calibrate_char = BLECharacteristic(0x2003);
BLECharacteristic admin_char = BLECharacteristic(0x2004);

BLEUart bleuart;

unsigned long sw1millis=0;
unsigned long sw2millis=0;

uint16_t bletemp=0;

bool ledstate=false;

bool enableBMP180BT=false;
bool enableBMP180nrF=false;
bool enableBLN=false;
bool enableBLNverbose=false;
bool enableGPSSerialBT=false;
bool debugBMP180=false;
bool debugBLN=false;
bool debugGPSSerialBT=false;
bool enableBMP2GPS=false;
bool enableDS18B20=false;

unsigned long blegpsmillis;
unsigned long blebmpmillis;
unsigned long bmp2gpsmillis;

char bmpstate='t';
uint32_t bmppoll=5000;
int32_t bmpsealevelpressure;
float bmppressure=0.0;

#define gpsPort Serial
#define DEBUG_PORT bleuart
#define GPS_PORT_NAME "Serial"
const uint32_t GPS_COMMAND_DELAY = 250;
static NMEAGPS gps;
gps_fix fix;
bool firstFix = false;

NeoGPS::Location_t last_location_heading = NeoGPS::Location_t(0.0,0.0);
uint16_t heading = 0;

const char disableRMC[] PROGMEM = "PUBX,40,RMC,0,0,0,0,0,0";
const char disableGLL[] PROGMEM = "PUBX,40,GLL,0,0,0,0,0,0";
const char disableGSV[] PROGMEM = "PUBX,40,GSV,0,0,0,0,0,0";
const char disableGSA[] PROGMEM = "PUBX,40,GSA,0,0,0,0,0,0";
const char disableGGA[] PROGMEM = "PUBX,40,GGA,0,0,0,0,0,0";
const char disableVTG[] PROGMEM = "PUBX,40,VTG,0,0,0,0,0,0";
const char disableZDA[] PROGMEM = "PUBX,40,ZDA,0,0,0,0,0,0";
const char disableGNS[] PROGMEM = "PUBX,40,GNS,0,0,0,0,0,0";
//const char disableGBS[] PROGMEM = "PUBX,40,GBS,0,0,0,0,0,0";
const char disableGST[] PROGMEM = "PUBX,40,GST,0,0,0,0,0,0";

const char enableRMC[] PROGMEM = "PUBX,40,RMC,0,1,0,0,0,0";
const char enableGLL[] PROGMEM = "PUBX,40,GLL,0,1,0,0,0,0";
const char enableGSV[] PROGMEM = "PUBX,40,GSV,0,1,0,0,0,0";
const char enableGSA[] PROGMEM = "PUBX,40,GSA,0,1,0,0,0,0";
const char enableGGA[] PROGMEM = "PUBX,40,GGA,0,1,0,0,0,0";
const char enableVTG[] PROGMEM = "PUBX,40,VTG,0,1,0,0,0,0";
const char enableZDA[] PROGMEM = "PUBX,40,ZDA,0,1,0,0,0,0";
const char enableGNS[] PROGMEM = "PUBX,40,GNS,0,1,0,0,0,0";
//const char enableGBS[] PROGMEM = "PUBX,40,GBS,0,1,0,0,0,0";
const char enableGST[] PROGMEM = "PUBX,40,GST,0,1,0,0,0,0";

//const char baud9600  [] PROGMEM = "PUBX,41,1,3,3,9600,0";
/*const char baud38400 [] PROGMEM = "PUBX,41,1,3,3,38400,0";
const char baud57600 [] PROGMEM = "PUBX,41,1,3,3,57600,0";
const char baud115200[] PROGMEM = "PUBX,41,1,3,3,115200,0";*/


const unsigned char ubxPortUART[] PROGMEM = { 0x06, 0x00, 0x14, 0x00, 0x01, 0x00, 0x00, 0x00, 0xC0, 0x08, 0x00, 0x00, 0x80, 0x25, 0x00, 0x00, 0x07, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char ubxPort1[] PROGMEM = { 0x06, 0x00, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x84, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char ubxPort2[] PROGMEM = { 0x06, 0x00, 0x14, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char ubxPort3[] PROGMEM = { 0x06, 0x00, 0x14, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char ubxNMEA[] PROGMEM = { 0x06, 0x17, 0x14, 0x00, 0x00, 0x41, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char ubxGNSS[] PROGMEM = { 0x06, 0x3E, 0x3C, 0x00, 0x00, 0x20, 0x20, 0x07, 0x00, 0x08, 0x10, 0x00, 0x01, 0x00, 0x01, 0x01, 0x01, 0x01, 0x03, 0x00, 0x01, 0x00, 0x01, 0x01, 0x02, 0x04, 0x08, 0x00, 0x01, 0x00, 0x01, 0x01, 0x03, 0x08, 0x10, 0x00, 0x00, 0x00, 0x01, 0x01, 0x04, 0x00, 0x08, 0x00, 0x00, 0x00, 0x01, 0x03, 0x05, 0x00, 0x03, 0x00, 0x00, 0x00, 0x01, 0x05, 0x06, 0x08, 0x0E, 0x00, 0x01, 0x00, 0x01, 0x01 };

const unsigned char ubxRate1s[] PROGMEM = { 0x06,0x08,0x06,0x00,0xE8,0x03,0x01,0x00,0x01,0x00 };
//const unsigned char ubxRate5s[] PROGMEM = { 0x06,0x08,0x06,0x00,0x88,0x13,0x01,0x00,0x01,0x00 };

const unsigned char GNSSStart[] PROGMEM = { 0x06,0x04,0x04,0x00,0x00,0x00,0x09,0x00 };
const unsigned char GNSSStop[] PROGMEM = { 0x06,0x04,0x04,0x00,0x00,0x00,0x08,0x00 };
const unsigned char saveConf[] PROGMEM = { 0x06, 0x09, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03 };

const unsigned char ContinuousMode[] PROGMEM = { 0x06,0x11,0x02,0x00,0x48,0x00 };
const unsigned char PSMMode[] PROGMEM = { 0x06,0x11,0x02,0x00,0x48,0x01 };

uint32_t gpsrate=3000;
uint32_t gpssendbt=10000;

template <typename T>
T bswap(T val) {
    T retVal;
    char *pVal = (char*) &val;
    char *pRetVal = (char*)&retVal;
    int size = sizeof(T);
    for(int i=0; i<size; i++) {
        pRetVal[size-1-i] = pVal[i];
    }

    return retVal;
}

void sendUBX( const unsigned char *progmemBytes, size_t len, bool wakeup )
{
  if(wakeup == true)
  {
    gpsPort.write( 0xFF );
    delay( 500 );
    
  }
  gpsPort.write( 0xB5 ); // SYNC1
  gpsPort.write( 0x62 ); // SYNC2

  uint8_t a = 0, b = 0;
  while (len-- > 0) {
    uint8_t c = pgm_read_byte( progmemBytes++ );
    a += c;
    b += a;
    gpsPort.write( c );
  }

  gpsPort.write( a ); // CHECKSUM A
  gpsPort.write( b ); // CHECKSUM B

} // sendUBX

static void printL( Print & outs, int32_t degE7 );
static void printL( Print & outs, int32_t degE7 )
{
  // Extract and print negative sign
  if (degE7 < 0) {
    degE7 = -degE7;
    outs.print( '-' );
  }

  // Whole degrees
  int32_t deg = degE7 / 10000000L;
  outs.print( deg );
  outs.print( '.' );

  // Get fractional degrees
  degE7 -= deg*10000000L;

  // Print leading zeroes, if needed
  int32_t factor = 1000000L;
  while ((degE7 < factor) && (factor > 1L)){
    outs.print( '0' );
    factor /= 10L;
  }
  
  // Print fractional degrees
  outs.print( degE7 );
}

void GPSChangeRateContinuous(uint32_t rate)
{
  Serial.println("GPS Mode: Normal");
  sendUBX( ContinuousMode, sizeof(ContinuousMode), false );
  delay( GPS_COMMAND_DELAY );
  sendUBX( saveConf, sizeof(saveConf), false );
  delay( GPS_COMMAND_DELAY );
  
  //uint16_t srate = (uint16_t)((float)(rate/4.0)*1000);
  char bit1 = (char)rate;
  char bit2 = (char)(rate >> 8);
  unsigned char ubxRate[] = { 0x06,0x08,0x06,0x00,bit1,bit2,0x01,0x00,0x01,0x00 };
  sendUBX( ubxRate, sizeof(ubxRate), false );
  delay( GPS_COMMAND_DELAY );
  sendUBX( saveConf, sizeof(saveConf), false );
}

void GPSChangeRateEco(uint32_t rate)
{
  GPSChangeRateContinuous(1000);
  delay(500);
  sendUBX( PSMMode, sizeof(PSMMode), false );
  delay( GPS_COMMAND_DELAY );
  sendUBX( saveConf, sizeof(saveConf), false );
  delay( GPS_COMMAND_DELAY );
  //uint16_t srate = (uint16_t)((float)(rate/4.0)*1000);
  uint8_t psmmode = 0x00;
  if(rate<10000)
  {
    psmmode = 0x42; // Cyclic
    Serial.println("GPS Mode: Eco Cyclic");
  } else {
    psmmode = 0x40; // ON/OFF
    Serial.println("GPS Mode: Eco ON/OFF");
  }
  char bit1 = (char)rate;
  char bit2 = (char)(rate >> 8);
  char bit3 = (char)(rate >> 16);
  char bit4 = (char)(rate >> 24);
  unsigned char pm2config[] = { 0x06, 0x3b, 0x2c, 0x00, 0x01, 0x06, 0x00, 0x00, 0x0e, 0x10, psmmode, 0x01, bit1, bit2, bit3, bit4, 0x10, 0x27, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2c, 0x01, 0x00, 0x00, 0x4f, 0xc1, 0x03, 0x00, 0x86, 0x02, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x64, 0x40, 0x01, 0x00};

  sendUBX( pm2config, sizeof(pm2config), false );
  delay( GPS_COMMAND_DELAY );
  sendUBX( saveConf, sizeof(saveConf), false );
}


void BMPChangeRate(uint16_t rate)
{
  bmppoll = (uint32_t)((float)(rate/4.0)*1000);
  Serial.print("BMP rate: ");
  Serial.println(bmppoll);
}

void calibrate_bmp2gps(int32_t gpselevation)
{
  /*bmp180.measurePressure();
  do
  {
    delay(100);
  } while (!bmp180.hasValue());
  bmppressure=bmp180.getPressure();*/
  bmpsealevelpressure = (int32_t)(bmppressure / pow(1.0-((float)gpselevation/100.0)/44330.0, 5.255)); //16180 100615
  bmp2gpsmillis = millis();  
  DEBUG_PORT.print("Calibrate bmp2gps ");
  DEBUG_PORT.print(bmppressure);
  DEBUG_PORT.print(" ");
  DEBUG_PORT.print(gpselevation);
  DEBUG_PORT.print(" ");
  DEBUG_PORT.println(bmpsealevelpressure);
}

void stopAdv_callback(void)
{
  sd_power_system_off();
}

void startAdv(void)
{
  // Advertising packet
  Bluefruit.Advertising.addFlags(BLE_GAP_ADV_FLAGS_LE_ONLY_GENERAL_DISC_MODE);
  Bluefruit.Advertising.addTxPower();

  Bluefruit.Advertising.addService(bleuart);

  Bluefruit.Advertising.addService(ln_service);
  Bluefruit.Advertising.addService(env_service);
  //Bluefruit.Advertising.addService(nrf_service);
  Bluefruit.Advertising.addService(custom_service);

  // Include Name
  Bluefruit.Advertising.addName();

  Bluefruit.Advertising.setStopCallback(stopAdv_callback);
  
  /* Start Advertising
   * - Enable auto advertising if disconnected
   * - Interval:  fast mode = 20 ms, slow mode = 152.5 ms
   * - Timeout for fast mode is 30 seconds
   * - Start(timeout) with timeout = 0 will advertise forever (until connected)
   * 
   * For recommended advertising interval
   * https://developer.apple.com/library/content/qa/qa1931/_index.html   
   */
  Bluefruit.Advertising.restartOnDisconnect(false);
  Bluefruit.Advertising.setInterval(32, 244);    // in unit of 0.625 ms
  Bluefruit.Advertising.setFastTimeout(30);      // number of seconds in fast mode
  Bluefruit.Advertising.start(900);                // 0 = Don't stop advertising after n seconds  
}


void initGPS()
{
  gpsPort.begin(9600); //GPS
  sendUBX( GNSSStart, sizeof(GNSSStart), true );
  delay( GPS_COMMAND_DELAY );
  sendUBX( ubxPortUART, sizeof(ubxPortUART), false );
  delay( GPS_COMMAND_DELAY );
  /*gpsPort.begin(115200); //GPS
  delay( GPS_COMMAND_DELAY );
  gps.send_P( &gpsPort, (const __FlashStringHelper *) baud9600 );
  delay( GPS_COMMAND_DELAY );*/
  sendUBX( ubxPort1, sizeof(ubxPort1), false );
  delay( GPS_COMMAND_DELAY );
  sendUBX( ubxPort2, sizeof(ubxPort2), false );
  delay( GPS_COMMAND_DELAY );
  sendUBX( ubxPort3, sizeof(ubxPort3), false );
  delay( GPS_COMMAND_DELAY );
  
  
  gps.send_P( &gpsPort, (const __FlashStringHelper *) disableGLL );
  delay( GPS_COMMAND_DELAY );
  gps.send_P( &gpsPort, (const __FlashStringHelper *) disableRMC );
  delay( GPS_COMMAND_DELAY );
  gps.send_P( &gpsPort, (const __FlashStringHelper *) disableGNS );
  delay( GPS_COMMAND_DELAY );
  gps.send_P( &gpsPort, (const __FlashStringHelper *) enableGST );
  delay( GPS_COMMAND_DELAY );
  // Bug ESP32 throuhput
  //gps.send_P( &gpsPort, (const __FlashStringHelper *) disableGSV );
  //delay( GPS_COMMAND_DELAY );
  
  
  sendUBX( ubxNMEA, sizeof(ubxNMEA), false );
  delay( GPS_COMMAND_DELAY );
  sendUBX( ubxGNSS, sizeof(ubxGNSS), false );
  delay( GPS_COMMAND_DELAY );

  /*sendUBX( GNSSStop, sizeof(GNSSStop), false );
  delay( GPS_COMMAND_DELAY );*/

 /* sendUBX( ubxRate1s, sizeof(ubxRate1s) );
  delay( GPS_COMMAND_DELAY );*/

  sendUBX( GNSSStop, sizeof(GNSSStop), true );
  
}

void onConf(uint16_t conn_hdl, BLECharacteristic* chr, uint8_t* confdata, uint16_t len) {
      //std::string confdata = pCharacteristicCB->getValue();
      

//      if (confdata.length() > 0) {
      /*  Serial.println("*********");
        Serial.print("New value: ");
        for (int i = 0; i < value.length(); i++)
          Serial.print(value[i]);

        Serial.println();
        Serial.println("*********");*/
        DEBUG_PORT.print("New conf: ");

        DEBUG_PORT.println(confdata[0]);
        if((confdata[0] & 0x01) != 0) { if(enableBMP180nrF==false) { Serial.println("BMP nrF");  enableBMP180nrF=true; } } else { if(enableBMP180nrF==true) { enableBMP180nrF=false; } }
        if((confdata[0] & 0x02) != 0) { if(enableBMP180BT==false) { Serial.println("BMP BT");  enableBMP180BT=true; } } else { if(enableBMP180BT==true) { enableBMP180BT=false; } }
        if((confdata[0] & 0x04) != 0) { if(enableBMP2GPS==false) { Serial.println("BMP2GPS");  enableBMP2GPS=true; } } else { if(enableBMP2GPS==true) { enableBMP2GPS=false; } }
        if((confdata[0] & 0x08) != 0) { if(enableDS18B20==false) { Serial.println("D18B20");  uint8_t selected = ds.select(ds18b20_addr); if (selected) { enableDS18B20=true; } } } else { if(enableDS18B20==true) { enableDS18B20=false; } }
        
        if((confdata[1] & 0x01) != 0) { 
          if(enableBLN==false) { 
            DEBUG_PORT.println("GPS BLE"); 
            enableBLN=true;
            if(enableGPSSerialBT==false) {
               sendUBX( GNSSStart, sizeof(GNSSStart), true );
               delay( GPS_COMMAND_DELAY );
            } else {
              enableGPSSerialBT=false;
              //SerialBT.end();
            }
            gps.send_P( &gpsPort, (const __FlashStringHelper *) enableGSV );
            delay( GPS_COMMAND_DELAY );
            gps.send_P( &gpsPort, (const __FlashStringHelper *) disableRMC );
            delay( GPS_COMMAND_DELAY );
          } 
        } else { 
            if(enableBLN==true) { 
              enableBLN=false;
            }
        }
        if((confdata[1] & 0x02) != 0) { 
          enableBLNverbose = true;
        } else {
          enableBLNverbose = false;
        }
        if((confdata[1] & 0x04) != 0) { 
          if(enableGPSSerialBT==false && enableBLN==false) { 
            enableGPSSerialBT=true;
            sendUBX( GNSSStart, sizeof(GNSSStart), true );
            delay( GPS_COMMAND_DELAY ); 
          }
          gps.send_P( &gpsPort, (const __FlashStringHelper *) disableGSV );
          delay( GPS_COMMAND_DELAY ); 
          gps.send_P( &gpsPort, (const __FlashStringHelper *) enableRMC );
          delay( GPS_COMMAND_DELAY ); 
        } else { 
          if(enableGPSSerialBT==true) { 
            enableGPSSerialBT=false;
            //SerialBT.end();
          } 
        }
        
        if(enableGPSSerialBT==false && enableBLN==false) {
          sendUBX( GNSSStop, sizeof(GNSSStop), true );
        }
        
        if(enableGPSSerialBT==true || enableBLN==true) {
          gpsrate = (uint32_t)((float)((confdata[2] | (confdata[3] << 8))/4.0)*1000);
          gpssendbt = (uint32_t)((float)((confdata[6] | (confdata[7] << 8))/4.0)*1000);
          DEBUG_PORT.print("GPS rate: ");
          DEBUG_PORT.println(gpsrate);
          DEBUG_PORT.print("GPS sendBT: ");
          DEBUG_PORT.println(gpssendbt);
          DEBUG_PORT.print("GPS Choose Mode: "); 
          
          if(((confdata[1] & 0x08) == 0) && (confdata[1] & 0x10) == 0) // Auto
          {
            DEBUG_PORT.println("Auto");
            if(gpsrate<5000)
            {
              GPSChangeRateContinuous(gpsrate);
            } else {
              GPSChangeRateEco(gpsrate);
            }
            
          } else if(((confdata[1] & 0x08) != 0) && (confdata[1] & 0x10) == 0) { // Normal
            DEBUG_PORT.println("Normal");
            if(gpsrate<=60000)
            {
              GPSChangeRateContinuous(gpsrate);
            } else {
              GPSChangeRateEco(gpsrate);
            }
          } else if(((confdata[0] & 0x20) == 0) && (confdata[0] & 0x40) != 0) { // Eco
            DEBUG_PORT.println("Eco");
            if(gpsrate<1000)
            {
              GPSChangeRateContinuous(gpsrate);
            } else {
              GPSChangeRateEco(gpsrate);
            }
          }
          
          
        }
        if(enableBMP180nrF==true || enableBMP180BT==true) {
          BMPChangeRate(confdata[4] | (confdata[5] << 8));
        }
      //pCharacteristicCB->setValue("Received OK");
    }

void onCalibrate(uint16_t conn_hdl, BLECharacteristic* chr, uint8_t* confdata, uint16_t len) {
  if(enableBMP2GPS == true)
  {
    int32_t userelevation = (int32_t)(confdata[0] | confdata[1] << 8 | confdata[2] << 16 | confdata[3] << 24);
    calibrate_bmp2gps(userelevation);
  }
}

void onAdmin(uint16_t conn_hdl, BLECharacteristic* chr, uint8_t* confdata, uint16_t len) {
  if(confdata[0] == 1)
  {
    BLEConnection* connection = Bluefruit.Connection(conn_hdl);
    connection->disconnect();
    NRF_POWER->GPREGRET = 0x4e;
    NVIC_SystemReset();
  }
}
/*
void sw2press()
{
  //Serial.println("Key SW2 press");
  //NRF_POWER->GPREGRET = 0x4e;
  //NVIC_SystemReset();
  if(digitalRead(13) == LOW)
  {
    sw2millis=millis();
  } else {
    sw2millis=0;
  }
}

void sw1press()
{
  //Serial.println("Key SW2 press");
  if(digitalRead(14) == LOW)
  {
    sw1millis=millis();
  } else {
    sw1millis=0;
  }
}
*/

void connect_callback(uint16_t conn_handle)
{
  // Get the reference to current connection
  BLEConnection* connection = Bluefruit.Connection(conn_handle);

  char central_name[32] = { 0 };
  connection->getPeerName(central_name, sizeof(central_name));

  DEBUG_PORT.print("Connected to ");
  DEBUG_PORT.println(central_name);
}

void disconnect_callback(uint16_t conn_handle, uint8_t reason)
{
  (void) conn_handle;
  (void) reason;
  
  enableBMP180BT=false;
  enableBMP180nrF=false;
  debugBMP180=false;
  enableDS18B20=false;
  if(enableBLN == true or enableGPSSerialBT == true) {
    enableBLN=false;
    enableBLNverbose=false;
    enableGPSSerialBT=false;
    debugBLN=false;
    debugGPSSerialBT=false;
    enableBMP2GPS=false;
    sendUBX( GNSSStop, sizeof(GNSSStop), true );
  }

  startAdv();
  
  //Serial.print("Disconnected, reason = 0x"); Serial.println(reason, HEX);
  //Serial.println("Advertising!");
}


void setupLNBT()
{
  ln_service.begin();
  ls_char.setProperties(CHR_PROPS_NOTIFY);
  ls_char.setPermission(SECMODE_OPEN, SECMODE_NO_ACCESS);
  ls_char.setFixedLen(20);
  ls_char.begin();
  pq_char.setProperties(CHR_PROPS_NOTIFY);
  pq_char.setPermission(SECMODE_OPEN, SECMODE_NO_ACCESS);
  pq_char.setFixedLen(16);
  pq_char.begin();
}
void setupPressureTemperatureBT()
{
  env_service.begin();
  pressure_char.setProperties(CHR_PROPS_NOTIFY);
  pressure_char.setPermission(SECMODE_OPEN, SECMODE_NO_ACCESS);
  pressure_char.setFixedLen(4);
  pressure_char.begin();
  temperature_char.setProperties(CHR_PROPS_NOTIFY);
  temperature_char.setPermission(SECMODE_OPEN, SECMODE_NO_ACCESS);
  temperature_char.setFixedLen(4);
  temperature_char.begin();
}
void setupPressureTemperatureNRFBT()
{
  bleuart.begin();
  pressure_nrf_char.setProperties(CHR_PROPS_NOTIFY);
  pressure_nrf_char.setPermission(SECMODE_OPEN, SECMODE_NO_ACCESS);
  pressure_nrf_char.setFixedLen(4);
  pressure_nrf_char.begin();
  temperature_nrf_char.setProperties(CHR_PROPS_NOTIFY);
  temperature_nrf_char.setPermission(SECMODE_OPEN, SECMODE_NO_ACCESS);
  temperature_nrf_char.setFixedLen(2);
  temperature_nrf_char.begin();
}
void setupCustomServiceBT()
{
  custom_service.begin();
  write_char.setProperties(CHR_PROPS_WRITE);
  write_char.setPermission(SECMODE_NO_ACCESS, SECMODE_OPEN);
  write_char.setWriteCallback(onConf);
  write_char.setFixedLen(8);
  write_char.begin();
  sat_char.setProperties(CHR_PROPS_NOTIFY);
  sat_char.setPermission(SECMODE_OPEN, SECMODE_NO_ACCESS);
  sat_char.setFixedLen(8);
  sat_char.begin();
  calibrate_char.setProperties(CHR_PROPS_WRITE);
  calibrate_char.setPermission(SECMODE_NO_ACCESS, SECMODE_OPEN);
  calibrate_char.setWriteCallback(onCalibrate);
  calibrate_char.setFixedLen(4);
  calibrate_char.begin();
  admin_char.setProperties(CHR_PROPS_WRITE);
  admin_char.setPermission(SECMODE_NO_ACCESS, SECMODE_OPEN);
  admin_char.setWriteCallback(onAdmin);
  admin_char.setFixedLen(1);
  admin_char.begin();
}

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  while ( !Serial ) delay(10);
  pinMode(LED_RED,OUTPUT);
  pinMode(13,INPUT);
  pinMode(14,INPUT);
  pinMode(LED_BLUE,OUTPUT);
  digitalWrite(LED_BLUE,LOW);
  //attachInterrupt(13, sw2press, ISR_DEFERRED | CHANGE);
  //attachInterrupt(14, sw1press, ISR_DEFERRED | CHANGE);

  blebmpmillis = millis();
  blegpsmillis = blebmpmillis;
  bmp2gpsmillis = 0;

  initGPS();
  //sendUBX( GNSSStart, sizeof(GNSSStart), true );

  Bluefruit.configPrphBandwidth(BANDWIDTH_MAX);
  Bluefruit.begin();
  //Bluefruit.setTxPower(-20);
  Bluefruit.setName("BT GPS");
  Bluefruit.Periph.setConnectCallback(connect_callback);
  Bluefruit.Periph.setDisconnectCallback(disconnect_callback);

  //bleuart.begin();
    
  setupLNBT();
  setupPressureTemperatureBT();
  setupPressureTemperatureNRFBT();
  setupCustomServiceBT();
  startAdv();
  
  Wire.begin();
  //begin() initializes the interface, checks the sensor ID and reads the calibration parameters.  
  if (!bmp180.begin())
  {
    DEBUG_PORT.println("begin() failed. check your BMP180 Interface and I2C Address.");
  }

  //reset sensor to default parameters.
  bmp180.resetToDefaults();

  //enable ultra high resolution mode for pressure measurements
  bmp180.setSamplingMode(BMP180MI::MODE_UHR);
    
    //ina219.begin();
    // To use a slightly lower 32V, 1A range (higher precision on amps):
    //ina219.setCalibration_32V_1A();
    // Or to use a lower 16V, 400mA range (higher precision on volts and amps):
    //ina219.setCalibration_16V_400mA();
  
}

int32_t bmp2gps(int32_t gpselevation, int gps_alt_err) {
  int32_t altitude;
  if(bmp2gpsmillis == 0  or (millis() - bmp2gpsmillis > 3600000))
  {
    calibrate_bmp2gps(gpselevation);
  }

  altitude = (int32_t) 44330 * (1.0 - pow(bmppressure /bmpsealevelpressure,0.1903)) * 100;
  
  return altitude;
}

uint8_t* parseSat()
{
     static uint8_t ret[2];
     uint8_t count_gps_all=0;
      uint8_t count_gps_used=0;
      uint8_t count_sbas_all=0;
      uint8_t count_sbas_used=0;
      uint8_t count_glonass_all=0;
      uint8_t count_glonass_used=0;
      uint8_t count_galileo_all=0;
      uint8_t count_galileo_used=0;

    for (uint8_t i=0; i < gps.sat_count; i++) {
      switch(gps.satellites[i].talker_id)
      {
        case 'P':
          if(gps.satellites[i].id > 32){
             count_sbas_all++;
            if(gps.satellites[i].tracked) count_sbas_used++;
          } else {
            count_gps_all++;
            if(gps.satellites[i].tracked) count_gps_used++;
          }
          break;
        case 'L':
          count_glonass_all++;
          if(gps.satellites[i].tracked) count_glonass_used++;
          break;
        case 'A':
          count_galileo_all++;
          if(gps.satellites[i].tracked) count_galileo_used++;
          break;
      }
    }
      //Serial.println("hehe");
      
      uint8_t blesat_bytes[8];
      memcpy(&blesat_bytes[0], &count_gps_all, 1 );
      memcpy(&blesat_bytes[1], &count_gps_used, 1 );
      memcpy(&blesat_bytes[2], &count_sbas_all, 1 );
      memcpy(&blesat_bytes[3], &count_sbas_used, 1 );
      memcpy(&blesat_bytes[4], &count_glonass_all, 1 );
      memcpy(&blesat_bytes[5], &count_glonass_used, 1 );
      memcpy(&blesat_bytes[6], &count_galileo_all, 1 );
      memcpy(&blesat_bytes[7], &count_galileo_used, 1 );

      sat_char.notify(&blesat_bytes, 8);

      ret[0]=count_gps_all+count_sbas_all+count_glonass_all+count_galileo_all;
      ret[1]=count_gps_used+count_sbas_used+count_glonass_used+count_galileo_used;
      return ret;
}

void parseGPS() {
 if(debugBLN==true) {
             if ( fix.dateTime.seconds < 10 )
      DEBUG_PORT.print( '0' );
    DEBUG_PORT.print( fix.dateTime.seconds );
    DEBUG_PORT.print( ',' );

    // DEBUG_PORT.print( fix.latitude(), 6 ); // floating-point display
    // DEBUG_PORT.print( fix.latitudeL() ); // integer display
    printL( DEBUG_PORT, fix.latitudeL() ); // prints int like a float
    DEBUG_PORT.print( ',' );
    // DEBUG_PORT.print( fix.longitude(), 6 ); // floating-point display
    // DEBUG_PORT.print( fix.longitudeL() );  // integer display
    printL( DEBUG_PORT, fix.longitudeL() ); // prints int like a float
    DEBUG_PORT.println();

 }
            
        uint8_t blels_bytes[20];
      //uint16_t flagsls= 0x05;
      uint16_t speed = int(fix.speed_kph()*100000/3600);
      if(last_location_heading.DistanceKm(fix.location) > 0.005)
      {
        heading = int(last_location_heading.BearingToDegrees(fix.location)*100.0);
        last_location_heading = fix.location;  
      }
      
      int32_t latitude = fix.latitudeL();
      int32_t longitude = fix.longitudeL();
      int32_t elevation;

      if(enableBMP2GPS==true)
      {
        elevation = bmp2gps(fix.altitude_cm(), fix.alt_err_cm);
      } else {
        elevation = fix.altitude_cm();
      }
      
      uint32_t ehpe=(uint32_t) round((fix.lat_err_cm+fix.lon_err_cm)/2);
      
      //memcpy(&blels_bytes, &flagsls, 2 );
      memcpy(&blels_bytes[0], &speed, 2 );
      memcpy(&blels_bytes[2], &latitude, 4 );
      memcpy(&blels_bytes[6], &longitude, 4 );
      memcpy(&blels_bytes[10], &ehpe, 4 );
      memcpy(&blels_bytes[14], &elevation, 4 );
      memcpy(&blels_bytes[18], &heading, 2 );
      
      
      //blels.latitude =  fix.latitude();
      //blels.longitude =  fix.longitude();
      //uint8_t* blels_bytes = static_cast<uint8_t*>(static_cast<void*>(&blels));
      
      ls_char.notify(&blels_bytes, 20);

      if(enableBLNverbose == true)
      {
        uint8_t *satstat=parseSat();
        
      uint8_t blepq_bytes[16];
      //uint16_t flagspq=0x05;
      uint8_t sat_view=satstat[0];
      uint8_t sat_used=satstat[1];
      uint32_t evpe=(uint32_t) fix.alt_err_cm;
      uint8_t hdop=(uint8_t) round(fix.hdop/200);
      uint8_t vdop=(uint8_t) round(fix.vdop/200);
      int32_t elevation_gps = fix.altitude_cm();
      
      //memcpy(&blepq_bytes, &flagspq, 2 );
      memcpy(&blepq_bytes[0], &sat_view, 1 );
      memcpy(&blepq_bytes[1], &sat_used, 1 );
      memcpy(&blepq_bytes[2], &ehpe, 4 );
      memcpy(&blepq_bytes[6], &evpe, 4 );
      memcpy(&blepq_bytes[10], &hdop, 1 );
      memcpy(&blepq_bytes[11], &vdop, 1 );
      memcpy(&blepq_bytes[12], &elevation_gps, 4 );

      pq_char.notify(&blepq_bytes, 16);
      } 
}

void loop() {
  
  // put your main code here, to run repeatedly:
  /*if(ledstate==false)
  {
    ledstate=true;
    digitalWrite(LED_RED, HIGH);
    Serial.println("LED On");
    bleuart.println("LED On");
  } else {
    ledstate=false;
    digitalWrite(LED_RED, LOW);
    Serial.println("LED Off");
    bleuart.println("LED Off");
  }*/
/*  if ( Bluefruit.connected() ) {
    bletemp++;
    uint16_t bletemp2=bletemp*10;
    uint8_t bledata[2];
    memcpy(&bledata, &bletemp2, 2 );
    temperature_char.notify(bledata, sizeof(bledata));
  }*/
  /*if(digitalRead(13) == HIGH)
  {
    Serial.println("1HIGH");
  } else {
    Serial.println("1LOW");
  }
    if(digitalRead(14) == HIGH)
  {
    Serial.println("2HIGH");
  } else {
    Serial.println("2LOW");
  }*/

  /*
  if(sw1millis != 0 and millis()-sw1millis > 5000)
  {
   NRF_POWER->GPREGRET = 0xa8;
   NVIC_SystemReset();
  }
  if(sw2millis != 0 and millis()-sw2millis > 1000)
  {
    NRF_POWER->GPREGRET = 0x4e;
    NVIC_SystemReset();
  }
  */

 /* float shuntvoltage = 0;
      float busvoltage = 0;
      float current_mA = 0;
      float loadvoltage = 0;
      float power_mW = 0;

        shuntvoltage = ina219.getShuntVoltage_mV();
      busvoltage = ina219.getBusVoltage_V();
      current_mA = ina219.getCurrent_mA();
      power_mW = ina219.getPower_mW();
      loadvoltage = busvoltage + (shuntvoltage / 1000);
     // total_mA += current_mA;

     // float total_mAh = total_mA / 3600.0;

      Serial.print("Bus Voltage:   "); Serial.print(busvoltage); Serial.println(" V");
      bleuart.print("Bus Voltage:   "); bleuart.print(busvoltage); bleuart.println(" V");
      Serial.print("Shunt Voltage: "); Serial.print(shuntvoltage); Serial.println(" mV");
      bleuart.print("Shunt Voltage: "); bleuart.print(shuntvoltage); bleuart.println(" mV");
      Serial.print("Load Voltage:  "); Serial.print(loadvoltage); Serial.println(" V");
      bleuart.print("Load Voltage:  "); bleuart.print(loadvoltage); bleuart.println(" V");
      Serial.print("Current:       "); Serial.print(current_mA); Serial.println(" mA");
      bleuart.print("Current:       "); bleuart.print(current_mA); bleuart.println(" mA");
      Serial.print("Power:         "); Serial.print(power_mW); Serial.println(" mW");
      bleuart.print("Power:         "); bleuart.print(power_mW); bleuart.println(" mW");
     // Serial.print("Consumption:   "); Serial.print(total_mAh); Serial.println(" mAh");
      Serial.println("");
      bleuart.println("");*/
if(enableBMP180nrF==true || enableBMP180BT==true || enableBMP2GPS == true)
  {  
        if(bmp180.hasValue())
  {
    if(bmpstate=='t')
    {
      float bmptemp;
      if(enableDS18B20 == true)
      {
        bmptemp=ds.getTempC();
      } else {
      bmptemp=bmp180.getTemperature();
      }
      bmpstate='p';
      if (!bmp180.measurePressure())
      {
        DEBUG_PORT.println("could not start perssure measurement, is a measurement already running?");
        return;
      }
      //float temp=bswap(bmptemp);
      if(enableBMP180BT==true)
      {
        int16_t temp=(int16_t)(bmptemp*100);
        temperature_char.notify(&temp, 2);
       // temperature_char.notify((const void*)bmptemp, sizeof(bmptemp));
      }
      if(enableBMP180nrF==true)
      {
        uint16_t blenrftemp1=(uint16_t)(bmptemp*10);
        uint16_t blenrftemp=bswap(blenrftemp1);
        temperature_nrf_char.notify16(blenrftemp);
      }
      if(debugBMP180==true)
      {
        DEBUG_PORT.print("Temperature: "); 
        DEBUG_PORT.print(bmptemp);
        DEBUG_PORT.println(" degC");
        
      }
    } else if(bmpstate=='p') {
      bmpstate=' ';
      bmppressure=bmp180.getPressure();
      
      uint32_t blenrfpressure1=(uint32_t)bmppressure;
      
      
      if(enableBMP180BT==true)
      {
        pressure_char.notify32(blenrfpressure1);
      }
      if(enableBMP180nrF==true)
      {
        uint32_t blenrfpressure=bswap(blenrfpressure1);
        pressure_nrf_char.notify32(blenrfpressure);
      }
      if(debugBMP180==true)
      {
        DEBUG_PORT.print("Pressure: "); 
        DEBUG_PORT.print(bmppressure);
        DEBUG_PORT.println(" Pa");
      }
    }
  }
  
  if(millis() > (blebmpmillis+bmppoll))
  {
    blebmpmillis=millis();

    if(enableDS18B20 == true)
    {
      if (!bmp180.measurePressure())
      {
        DEBUG_PORT.println("could not start perssure measurement, is a measurement already running?");
        return;
      }
    } else {
    if (!bmp180.measureTemperature())
    {
      DEBUG_PORT.println("could not start temperature measurement, is a measurement already running?");
      return;
    }
    
    }
    bmpstate='t';
    //level++;
    
    //if (int(level)==100)
    //level=0;
  }
  }

    if ((enableGPSSerialBT==true || enableBLN==true) && gpsPort.available()) {

    if(enableGPSSerialBT==true)
    {
      
    // Delay to wait for enough input, since we have a limited transmission buffer
    delay(2);

    uint8_t buf[64];
    int count = Serial.readBytes(buf, sizeof(buf));
    bleuart.write( buf, count );

  // Forward from BLEUART to HW Serial
  if ( bleuart.available() )
  {
    uint8_t ch;
    ch = (uint8_t) bleuart.read();
    Serial.write(ch);
  }
   
    } else if(enableBLN==true) {
		if(gps.available(gpsPort))
		{
      fix = gps.read();
      firstFix = true;
  }
      
  
          if((firstFix == true) && (((gpssendbt <= gpsrate) && millis() > (blegpsmillis+gpsrate)) || millis() > (blegpsmillis+gpssendbt)))
          {
            blegpsmillis = millis();
            if (fix.valid.location) {		
            parseGPS();
            } else {
              parseSat();
    }
    }
    }
    }

 
//delay(1000);
}
